from behave import given, when, then

from selenium.webdriver.common.by import By
from selenium.webdriver.common.action_chains import ActionChains


@given(u'Я открыл страницу "Входа"')
def open_login_page(context):
    context.browser.get('http://localhost:1026/auth/login/')


@when(u'Я ввожу текст "{text}" в поле "{name}"')
def enter_text(context, text, name):
    context.browser.find_element(By.NAME, name).send_keys(text)
    

@when(u'Я отправляю форму')
def submit_form(context):
    button = context.browser.find_element(By.CLASS_NAME, 'btn')
    context.browser.implicitly_wait(10)
    ActionChains(context.browser).move_to_element(button).click(button).perform()


@then(u'Я должен быть на главной странице')
def should_be_at_main_page(context):
    assert context.browser.current_url == 'http://localhost:1026/articles/'


@then(u'Я должен быть на странице входа')
def should_be_at_login_page(context):
    assert context.browser.current_url == 'http://localhost:1026/auth/login/?next='


@then(u'Я должен видеть сообщение об ошибке')
def should_see_error(context):
    error = context.browser.find_element(By.CLASS_NAME, 'alert-danger')
    assert error.text == 'Пожалуйста, введите правильные имя пользователя и пароль. Оба поля могут быть чувствительны к регистру.'
